﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace CWFApp1
{
    public partial class Book : Form
    {
        // Variables

        //connection
        System.Data.OleDb.OleDbConnection BConnection1 = new System.Data.OleDb.OleDbConnection();
        // Select command
        System.Data.OleDb.OleDbCommand SelectCMDda;
        System.Data.OleDb.OleDbCommand SelectCMD;
        // Data adapter
        System.Data.OleDb.OleDbDataAdapter Da = new System.Data.OleDb.OleDbDataAdapter();
        System.Data.OleDb.OleDbDataAdapter BookDA = new System.Data.OleDb.OleDbDataAdapter();
        //Dataset
        System.Data.DataSet KJVDSet;


        int Vrow;
        int Vposition;
        int View_Listview = 0;

        public Book()
        {
            InitializeComponent();
        }


        /// 1- DataBase - Resize, View, Navigation  and Show Forms
        private void Book_Load(object sender, EventArgs e)
        {

            this.BConnection1.ConnectionString = @"Provider=""Microsoft.Jet.OLEDB.4.0"";Data Source =|DataDirectory|\pic\KJV2002.mdb;Persist Security Info=False;User ID=Admin;Mode=Share Deny None;Jet OLEDB:Engine Type=5;Jet OLEDB:Database Locking Mode=1;Jet OLEDB:Global Partial Bulk Ops=2;Jet OLEDB:Global Bulk Transactions=1;Jet OLEDB:Create System Database=False;Jet OLEDB:Encrypt Database=False;Jet OLEDB:Don't Copy Locale on Compact=False;Jet OLEDB:Compact Without Replica Repair=False;Jet OLEDB:SFP=False";

            try
            {
                // Attempt to load the dataset.
                this.LoadDataSet();
                // display the 2nd record of The 'BibleTable' table 
                this.BindingContext[this.kjV2002BookDSet1, "BibleTable"].Position = 2;

            }


            catch (System.Exception eLoad)
            {
                // Add your error handling code here.
                // Display error message, if any.
                System.Windows.Forms.MessageBox.Show(eLoad.Message);
            }
            this.KJV2002BookDSet1_PositionChanged();
            // Navigation controls, enebled(False or True
            NavigationFP(false);
            NavigationNL(true);


            //Combobox
            this.Cmbtitle.Text = "Select";

            for (Vrow = 2; Vrow <= this.kjV2002BookDSet1.BibleTable.Rows.Count - 1; Vrow++)
            {

                if ((this.kjV2002BookDSet1.BibleTable.Rows[Vrow]["Chapter"].ToString() == "001") && (this.kjV2002BookDSet1.BibleTable.Rows[Vrow]["Verse"].ToString() == "001"))
                {
                    this.Cmbtitle.Items.Add(this.kjV2002BookDSet1.BibleTable.Rows[Vrow]["BookTitle"].ToString());
                    this.Cmbbook.Items.Add(this.kjV2002BookDSet1.BibleTable.Rows[Vrow]["Book"].ToString());
                }
            }

            //View is Detail

            View_Listview = 1;
            this.Btnview.Text = "View Details";
            this.ListView0.View = View.Details;

            //ComboBox
            this.Cmbtitle.Text = "Select";
            this.Cmbbook.Text = "Select";
            this.Cmbchapter.Text = "no select";
            this.Cmbverse.Text = "no select";

        }


        public void LoadDataSet()
        {

            // Create a new dataset to hold the records returned from the call to FillDataSet.
            // A temporary dataset is used because filling the existing dataset would
            // require the databindings to be rebound.
            CWFApp1.KJV2002BookDSet ObjDataSetTemp;
            ObjDataSetTemp = new CWFApp1.KJV2002BookDSet();
            try
            {
                // Attempt to fill the temporary dataset.
                this.FillDataSet(ObjDataSetTemp);
            }
            catch (System.Exception eFillDataSet)
            {
                // Add your error handling code here.
                throw eFillDataSet;
            }
            try
            {
                // Empty the old records from the dataset.
                this.kjV2002BookDSet1.Clear();
                // Merge the records into the main dataset.
                this.kjV2002BookDSet1.Merge(ObjDataSetTemp);
            }
            catch (System.Exception eLoadMerge)
            {
                // Add your error handling code here.
                throw eLoadMerge;
            }

        }


        public void FillDataSet(CWFApp1.KJV2002BookDSet dataSet)
        {
            // Turn off constraint checking before the dataset is filled.
            // This allows the adapters to fill the dataset without concern
            // for dependencies between the tables.
            dataSet.EnforceConstraints = false;
            SelectCMDda = new System.Data.OleDb.OleDbCommand("SELECT Book, BookTitle, Chapter, Verse, TextData FROM BibleTable ORDER BY Book, Chapter, Verse", BConnection1);
            SelectCMDda.Connection = BConnection1;
            Da.SelectCommand = SelectCMDda;
            try
            {
                // Open the connection.
                BConnection1.Open();
                // Attempt to fill the dataset through the DataAdapter da.
                Da.Fill(dataSet, "BibleTable");
            }
            catch (System.Exception fillException)
            {
                // Add your error handling code here.
                throw fillException;
            }
            finally
            {
                // Turn constraint checking back on.
                dataSet.EnforceConstraints = true;
                // Close the connection whether or not the exception was thrown.
                BConnection1.Close();
            }
        }
        private void NavigationFP(Boolean bval)
        {
            this.Fbutton1.Enabled = bval;
            this.Pbutton2.Enabled = bval;
        }
        private void NavigationNL(Boolean bval)
        {
            this.Nbutton3.Enabled = bval;
            this.Lbutton4.Enabled = bval;
        }

        private void KJV2002BookDSet1_PositionChanged()
        {
            //Database, displays Values of order and Fields - (Book, Booktitle, Chapter, Verse, BookText)
            Vposition = (this.BindingContext[this.kjV2002BookDSet1, "BibleTable"].Position);

            this.BtextBox1.Text = this.kjV2002BookDSet1.BibleTable.Rows[Vposition]["Book"].ToString();
            this.BTtextBox2.Text = this.kjV2002BookDSet1.BibleTable.Rows[Vposition]["BookTitle"].ToString();
            this.CtextBox3.Text = this.kjV2002BookDSet1.BibleTable.Rows[Vposition]["Chapter"].ToString();
            this.VtextBox4.Text = this.kjV2002BookDSet1.BibleTable.Rows[Vposition]["Verse"].ToString();
            this.TDtextBox1.Text = this.kjV2002BookDSet1.BibleTable.Rows[Vposition]["TextData"].ToString();

            //Navigation
            this.PItextBox1.Text = (this.BindingContext[this.kjV2002BookDSet1, "BibleTable"].Position).ToString();
            this.CtextBox2.Text = "of  " + (this.BindingContext[this.kjV2002BookDSet1, "BibleTable"].Count - 1).ToString();

            // Navigation controls enebled(True or False
            if ((this.BindingContext[this.kjV2002BookDSet1, "BibleTable"].Position) <= 2)
            {
                NavigationFP(false);
                NavigationNL(true);
            }
            else
            {
                if ((this.BindingContext[this.kjV2002BookDSet1, "BibleTable"].Position + 1) >= (this.BindingContext[this.kjV2002BookDSet1, "BibleTable"].Count))
                {
                    NavigationFP(true);
                    NavigationNL(false);
                }
                else
                {
                    NavigationFP(true);
                    NavigationNL(true);
                }
            }

        }

        private void Fbutton1_Click(object sender, EventArgs e)
        {
            this.BindingContext[this.kjV2002BookDSet1, "BibleTable"].Position = 2;
            this.KJV2002BookDSet1_PositionChanged();
        }

        private void Pbutton2_Click(object sender, EventArgs e)
        {
            if (this.BindingContext[this.kjV2002BookDSet1, "BibleTable"].Position > 2)
            {
                this.BindingContext[this.kjV2002BookDSet1, "BibleTable"].Position = (this.BindingContext[this.kjV2002BookDSet1, "BibleTable"].Position - 1);
                this.KJV2002BookDSet1_PositionChanged();
            }

        }

        private void Nbutton3_Click(object sender, EventArgs e)
        {
            this.BindingContext[this.kjV2002BookDSet1, "BibleTable"].Position = (this.BindingContext[this.kjV2002BookDSet1, "BibleTable"].Position + 1);
            this.KJV2002BookDSet1_PositionChanged();

        }

        private void Lbutton4_Click(object sender, EventArgs e)
        {
            this.BindingContext[this.kjV2002BookDSet1, "BibleTable"].Position = (this.kjV2002BookDSet1.Tables["BibleTable"].Rows.Count - 1);
            this.KJV2002BookDSet1_PositionChanged();
        }



        /// 2- Search - ListView Control> ============================================================


        private void Btnsearch_Click(object sender, EventArgs e)
        {

            // Variable
            int IFound = 0;

            // Clear ...

            this.ListView0.Clear();

            // Allow the user to edit item text.
            this.ListView0.LabelEdit = true;
            // Allow the user to rearrange columns.
            this.ListView0.AllowColumnReorder = true;
            // Select the item and subitems when selection is made.
            this.ListView0.FullRowSelect = true;
            // Display grid lines.
            this.ListView0.GridLines = true;

            // Column Header   
            this.ListView0.Columns.Add("Record #", 60, HorizontalAlignment.Center);
            this.ListView0.Columns.Add("Book", 45, HorizontalAlignment.Left);
            this.ListView0.Columns.Add("Book title", 80, HorizontalAlignment.Left);
            this.ListView0.Columns.Add("Chapter", 55, HorizontalAlignment.Left);
            this.ListView0.Columns.Add("Verse", 55, HorizontalAlignment.Left);

            // for (Vrow = 2; Vrow <= this.kjV2002BookDSet1.BibleTable.Rows.Count - 1; Vrow++)
            for (Vrow = 2; Vrow <= this.kjV2002BookDSet1.BibleTable.Rows.Count - 1; Vrow++)

            {
                // Use RichEdit control to store TextData field
                this.TDWtextBox1.Text = this.kjV2002BookDSet1.BibleTable.Rows[Vrow]["TextData"].ToString().ToLower();

                // Search by Word operation, Use the Find function of RichText control if the TxtWord Value exist
                if (this.TDWtextBox1.Find(this.TxtWord.Text.ToLower()) != -1)
                {
                    // Create item and four sets of subitems.
                    ListViewItem item1 = new ListViewItem(System.Convert.ToString(Vrow), 0);



                    // Place a check mark next to the item.
                    item1.SubItems.Add(this.kjV2002BookDSet1.BibleTable.Rows[Vrow]["Book"].ToString());
                    item1.SubItems.Add(this.kjV2002BookDSet1.BibleTable.Rows[Vrow]["BookTitle"].ToString());
                    item1.SubItems.Add(this.kjV2002BookDSet1.BibleTable.Rows[Vrow]["Chapter"].ToString());
                    item1.SubItems.Add(this.kjV2002BookDSet1.BibleTable.Rows[Vrow]["Verse"].ToString());


                    //Add the items to the ListView.
                    ListView0.Items.AddRange(new ListViewItem[] { item1 });

                    // Number of verse found
                    IFound = IFound + 1;

                    if (IFound > 5000)
                    {
                        this.lbinfo1.Text = " Search results for [" + this.TxtWord.Text + "] - more then" + System.Convert.ToString(IFound) + " verses found.";

                        goto ExitPt;
                    }
                }
            }

            //'Display the number of items found

            if (IFound > 0)
                this.lbinfo1.Text = " Search results for [" + this.TxtWord.Text + "] - " + System.Convert.ToString(IFound) + " verses found.";
            else
            {
                this.lbinfo1.Text = " Search results for [" + this.TxtWord.Text + "] - 0 verse found.";
            }
        ExitPt:
            this.TxtWord.Text = "";
            this.TxtWord.Enabled = true;
            this.Btnsearch.Enabled = false;
            this.Btnview.Enabled = true;
        }

        private void TxtWord_KeyPress(object sender, KeyPressEventArgs e)
        {
            // btnSearch is enabled, if the lenght of the word typed in the TxtWord control > 1

            if (this.TxtWord.Text.Length >= 1)

            {

                this.Btnsearch.Enabled = true;
                this.Btnview.Enabled = false;

            }

        }

        private void Btnview_Click(object sender, EventArgs e)
        {
            View_Listview = View_Listview + 1;

            switch (View_Listview)

            {

                case 1:

                    this.ListView0.View = View.Details;
                    this.Btnview.Text = "View Details";

                    break;

                case 2:

                    this.ListView0.View = View.LargeIcon;
                    this.Btnview.Text = "View L Icon";

                    break;

                case 3:

                    this.ListView0.View = View.List;
                    this.Btnview.Text = "View List";
                    break;

                case 4:

                    this.ListView0.View = View.SmallIcon;
                    this.Btnview.Text = "View S Icon";
                    break;

                case 5:

                    goto case 1;


            }
        }

        private void ListView0_Click(object sender, EventArgs e)
        {
            this.BindingContext[this.kjV2002BookDSet1, "BibleTable"].Position = System.Convert.ToInt16(this.ListView0.SelectedItems[0].Text); // convert string to int
            this.KJV2002BookDSet1_PositionChanged();
        }


        /// <3- Search by address - Combobox Controls> ============================================================


        private void Cmbtitle_SelectedIndexChanged(object sender, EventArgs e)
        {
            int VPosition = 0;
            
            //Initialize table BibleTable
            this.InitCmb();

            /**
             * 1- Cmbbook stores the orders of all books.
             * 2- Cmbtitle stores the titles of books
             * 3- The Cmbchapter stores all chapters orders of the book corresponding to the item selected
             * 4- The Cmbverse stores all verses orders of the 1st chapter of the book
            **/
            this.Cmbchapter.Items.Clear();
            this.Cmbverse.Items.Clear();
            for (Vrow = 2; Vrow <= KJVDSet.Tables["BibleTable"].Rows.Count - 1; Vrow++)
            {
                if ((KJVDSet.Tables["BibleTable"].Rows[Vrow]["BookTitle"].ToString() == this.Cmbtitle.SelectedItem.ToString()) && (KJVDSet.Tables["BibleTable"].Rows[Vrow]["Chapter"].ToString() == "001") && (KJVDSet.Tables["BibleTable"].Rows[Vrow]["Verse"].ToString() == "001"))
                {
                    VPosition = Vrow;
                    this.Cmbchapter.Items.Add(KJVDSet.Tables["BibleTable"].Rows[Vrow]["Chapter"].ToString());
                    this.Cmbverse.Items.Add(KJVDSet.Tables["BibleTable"].Rows[Vrow]["Verse"].ToString());
                    goto NextA1;
                }
            }

        NextA1:
            for (Vrow = VPosition + 1; Vrow <= KJVDSet.Tables["BibleTable"].Rows.Count - 1; Vrow++)
            {
                if (KJVDSet.Tables["BibleTable"].Rows[Vrow]["BookTitle"].ToString() == this.Cmbtitle.SelectedItem.ToString())
                {
                    if (KJVDSet.Tables["BibleTable"].Rows[Vrow]["Chapter"].ToString() == "001")
                    {
                        this.Cmbverse.Items.Add(KJVDSet.Tables["BibleTable"].Rows[Vrow]["Verse"].ToString());
                    }
                    else
                    {
                        if (KJVDSet.Tables["BibleTable"].Rows[Vrow]["Verse"].ToString() == "001")
                        {
                            this.Cmbchapter.Items.Add(KJVDSet.Tables["BibleTable"].Rows[Vrow]["Chapter"].ToString());
                        }
                    }
                }
            }
            /**
             * 1- The record displays into the Record data boxes, includes the following data:
             * the order and title of the book corresponding to the item selected,
             * the 1st chapter order of the book,
             * the 1st verse order of the 1st chapter
             * and the contents of the verse.
             * 2- In the Cmbtitle, displays the item selected
             * 3- In the Cmbbook, displays the title of the book corresponding to the item selected
             * 4- In the Cmbchapter, displays the 1st chapter order of the book
             * 5- In the Cmbverse, displays the 1st verse order of the 1st chapter
            **/
            this.BindingContext[this.kjV2002BookDSet1, "BibleTable"].Position = VPosition;
            this.KJV2002BookDSet1_PositionChanged();
            this.Cmbbook.SelectedIndex = this.Cmbtitle.SelectedIndex;
            this.Cmbchapter.SelectedIndex = 0;
            this.Cmbverse.SelectedIndex = 0;

        }

        private void InitCmb()
        {
            SelectCMD = new System.Data.OleDb.OleDbCommand("SELECT Book, BookTitle, Chapter, Verse, TextData FROM BibleTable ORDER BY Book, Chapter, Verse", BConnection1);
            SelectCMD.Connection = BConnection1;
            BookDA.SelectCommand = SelectCMD;
            KJVDSet = new System.Data.DataSet();
            BConnection1.Open();
            BookDA.Fill(KJVDSet, "BibleTable");
            BConnection1.Close();
        }

        private void Cmbbook_SelectedIndexChanged(object sender, EventArgs e)
        {
            int VPosition = 0;

            //Initialize table BibleTable
            this.InitCmb();

            /**1- Cmbbook stores the orders of all books.
             * 2- Cmbtitle stores the titles of books
             * 3- The Cmbchapter stores all chapters orders of the book corresponding to the item selected
             * 4- The Cmbverse stores all verses orders of the 1st chapter of the book
             **/
            this.Cmbchapter.Items.Clear();
            this.Cmbverse.Items.Clear();
            for (Vrow = 2; Vrow <= KJVDSet.Tables["BibleTable"].Rows.Count - 1; Vrow++)
            {
                if ((KJVDSet.Tables["BibleTable"].Rows[Vrow]["Book"].ToString() == this.Cmbbook.SelectedItem.ToString()) && (KJVDSet.Tables["BibleTable"].Rows[Vrow]["Chapter"].ToString() == "001") && (KJVDSet.Tables["BibleTable"].Rows[Vrow]["Verse"].ToString() == "001"))
                {
                    VPosition = Vrow;
                    this.Cmbchapter.Items.Add(KJVDSet.Tables["BibleTable"].Rows[Vrow]["Chapter"].ToString());
                    this.Cmbverse.Items.Add(KJVDSet.Tables["BibleTable"].Rows[Vrow]["Verse"].ToString());
                    goto NextA2;
                }
            }
        NextA2:
            for (Vrow = VPosition + 1; Vrow <= KJVDSet.Tables["BibleTable"].Rows.Count - 1; Vrow++)
            {
                if ((KJVDSet.Tables["BibleTable"].Rows[Vrow]["Book"].ToString() == this.Cmbbook.SelectedItem.ToString()))
                {
                    if (KJVDSet.Tables["BibleTable"].Rows[Vrow]["Chapter"].ToString() == "001")
                    {
                        this.Cmbverse.Items.Add(KJVDSet.Tables["BibleTable"].Rows[Vrow]["Verse"].ToString());
                    }
                    else
                    {
                        if (KJVDSet.Tables["BibleTable"].Rows[Vrow]["Verse"].ToString() == "001")
                        {
                            this.Cmbchapter.Items.Add(KJVDSet.Tables["BibleTable"].Rows[Vrow]["Chapter"].ToString());
                        }
                    }
                }
            }
            /**
             * 1- The record displays into the Record data boxes, includes the following data:
             * he order and title of the book corresponding to the item selected,
             * the 1st chapter order of the book,
             * the 1st verse order of the 1st chapter
             * and the contents of the verse.
             * 2- In the Cmbtitle, displays the title of the book corresponding to the item selected
             * 3- In the Cmbbook, displays the item selected
             * 4- In the Cmbchapter, displays the 1st chapter order of the book
             * 5- In the Cmbverse, displays the 1st verse order of the 1st chapter
            **/
            this.BindingContext[this.kjV2002BookDSet1, "BibleTable"].Position = VPosition;
            this.KJV2002BookDSet1_PositionChanged();
            this.Cmbtitle.SelectedIndex = this.Cmbbook.SelectedIndex;
            this.Cmbchapter.SelectedIndex = 0;
            this.Cmbverse.SelectedIndex = 0;
        }

        private void Cmbchapter_SelectedIndexChanged(object sender, EventArgs e)
        {
            int VPosition = 0;

            //Initialize table BibleTable
            this.InitCmb();

            this.Cmbverse.Items.Clear();
            for (Vrow = 2; Vrow <= KJVDSet.Tables["BibleTable"].Rows.Count - 1; Vrow++)
            {
                if ((KJVDSet.Tables["BibleTable"].Rows[Vrow]["Book"].ToString() == this.Cmbbook.Text) && (KJVDSet.Tables["BibleTable"].Rows[Vrow]["Chapter"].ToString() == this.Cmbchapter.SelectedItem.ToString()) && (KJVDSet.Tables["BibleTable"].Rows[Vrow]["Verse"].ToString() == "001"))
                {
                    VPosition = Vrow;
                    this.Cmbverse.Items.Add(KJVDSet.Tables["BibleTable"].Rows[Vrow]["Verse"].ToString());
                    goto NextA3;
                }
            }
        NextA3:
            for (Vrow = VPosition + 1; Vrow <= KJVDSet.Tables["BibleTable"].Rows.Count - 1; Vrow++)
            {
                if ((KJVDSet.Tables["BibleTable"].Rows[Vrow]["Book"].ToString() == this.Cmbbook.Text) && (KJVDSet.Tables["BibleTable"].Rows[Vrow]["Chapter"].ToString() == this.Cmbchapter.SelectedItem.ToString()))
                {
                    this.Cmbverse.Items.Add(KJVDSet.Tables["BibleTable"].Rows[Vrow]["Verse"].ToString());
                }
            }
            /**
             * 1- The record displays into the Record data boxes, includes the following data:
             * the order and title of the book corresponding to the item selected,
             * the 1st chapter order of the book,
             * the 1st verse order of the 1st chapter
             * and the contents of the verse.
             * 2- In the Cmbtitle, displays the title of the book 
             * 3- In the Cmbbook, displays the title of the book 
             * 4- In the Cmbchapter, displays the item selected
             * 5- In the Cmbverse, displays the 1st verse order of the 1st chapter
            **/
            this.BindingContext[this.kjV2002BookDSet1, "BibleTable"].Position = VPosition;
            this.KJV2002BookDSet1_PositionChanged();
            this.Cmbverse.SelectedIndex = 0;

        }

        private void Cmbverse_SelectedIndexChanged(object sender, EventArgs e)
        {
            int VPosition = 0;

            //Initialize table BibleTable
            this.InitCmb();

            for (Vrow = 2; Vrow <= KJVDSet.Tables["BibleTable"].Rows.Count - 1; Vrow++)
            {
                if ((KJVDSet.Tables["BibleTable"].Rows[Vrow]["Book"].ToString() == this.Cmbbook.Text) && (KJVDSet.Tables["BibleTable"].Rows[Vrow]["Chapter"].ToString() == this.Cmbchapter.Text) && (KJVDSet.Tables["BibleTable"].Rows[Vrow]["Verse"].ToString() == this.Cmbverse.SelectedItem.ToString()))
                {
                    VPosition = Vrow;
                    goto NextA4;
                }
            }
        NextA4:
            /**
             * 1- The record displays into the Record data boxes, includes the following data:
             * the order and title of the book corresponding to the item selected,
             * the 1st chapter order of the book,
             * the 1st verse order of the 1st chapter
             * and the contents of the verse.
             * 2- In the Cmbtitle, displays the title of the book 
             * 3- In the Cmbbook, displays the title of the book 
             * 4- In the Cmbchapter, displays the book chapter
             * 5- In the Cmbverse, displays the item selected
            **/
            this.BindingContext[this.kjV2002BookDSet1, "BibleTable"].Position = VPosition;
            this.KJV2002BookDSet1_PositionChanged();

        }

        private void Dbutton1_Click(object sender, EventArgs e)
        { 
            this.Close();
            // show MainForm ...";
            CWFApp1.MainForm Fmain = new MainForm();
            Fmain.Show();
            Fmain.Refresh(); 
        }

        private void Book_FormClosed(object sender, FormClosedEventArgs e)
        {
            // show MainForm ...";
            CWFApp1.MainForm Fmain = new MainForm();
            Fmain.Show();
            Fmain.Refresh();
        }
    }
}

        